#!/bin/sh		# -*- coding: iso-8859-15; -*-
#set -x
#	@(#) bash-script.sh 1.0
#	Time-stamp: <2006-12-26 23:00:56 pete>
#
#############################################################################
#
# Purpose: provide DISPLAY variable to MacTeX commands for bash in Terminal
# Copyright (C) 2006	Peter Dyballa -- (F)Lawless Software Team, F(l)ST
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
#
#
# Theory of operation
#
# In order to prepare a running bash in Terminal with a *PRELIMINARY* value for
# DISPLAY these lines are added to .bash_profile.
# Too, a shell function, updisp, is added that can be executed in Terminal in
# case the DISPLAY value after launching X11 is different from the preliminary
# value, so that it is updated and corrected.
#
#############################################################################
#
Datum=`date "+%+"`
 Fund=0
if [ -f .bash_profile ]; then				# has .bash_profile already the function updisp defined?
    Fund=`grep -w updisp  .bash_profile | grep '()' | tr -d '   ' | grep -v '^#' | wc -l`
    if [ $Fund -eq 0 ]; then
      	mv  .bash_profile ".bash_profile-${Datum}"      # then save .bash_profile
      	cp ".bash_profile-${Datum}" .bash_profile       # prepare a copy of original .bash_profile
    fi
fi
if [ $Fund -eq 0 ]; then
    cat <<-'EOF' | sed -e "s/%%Datum%%/$Datum/" >> .bash_profile
	#
	#	This change was added on %%Datum%%
	#
	if [ -z "$DISPLAY" ]; then
	    PID=`ps -lwx | egrep -w 'X11|XDarwin' | grep -v grep | awk '{print $2}' | head -1`
	    if [ -n "$PID" ]; then
	        export DISPLAY=`ps -wwwe -p $PID | grep DISPLAY | sed -e 's/^.*DISPLAY=\([^ ]*\) .*$/\1/'`
	    else 
	        Anzahl=`top -FRl 1 | grep Finder | wc -l`       # OR loginwindo OR ATSServer OR SystemUIServer OR Dock OR pbs ...
	        Anzahl=`expr $Anzahl - 1`
	        export DISPLAY=:${Anzahl}
	    fi
	fi
	updisp	() { export DISPLAY=`defaults read "${HOME}/.MacOSX/environment" DISPLAY` ; }
	#
	#	End of change from %%Datum%%
EOF
else
    echo "......#######################################################"
    echo "....... Your ~/.bash_profile might already contain all the"
    echo "....... necessary things to make a Mac TeX work in X11 ..."
    echo "....... But you better check this!"
    echo "......#######################################################"
    exit 1
fi
