#!/bin/sh		# -*- coding: iso-8859-15; -*-
#set -x
#	@(#) tcshrc-script.sh 1.0
#	Time-stamp: <2006-12-26 21:20:42 pete>
#
#############################################################################
#
# Purpose: provide DISPLAY variable to MacTeX commands for (t)csh in Terminal
# Copyright (C) 2006	Peter Dyballa -- (F)Lawless Software Team, F(l)ST
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
# Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
#
#
# Theory of operation
#
# In order to prepare a running tcsh in Terminal with a *PRELIMINARY* value for
# DISPLAY these lines are added to .login.
# Too, a shell alias, updisp, is added that can be executed in Terminal in
# case the DISPLAY value after launching X11 is different from the preliminary
# value, so that it is updated and corrected.
# 
#############################################################################
#
Datum=`date "+%+"`
 Fund=0
if [ -f .login ]; then					# has .login already the alias updisp defined?
    Fund=`grep -w updisp .login | grep -w alias | tr -d ' 	' | grep -v '^#' | wc -l`
    if [ $Fund -eq 0 ]; then
	mv  .login ".login-${Datum}"			# then save .login
	cp ".login-${Datum}" .login       		# prepare a copy of original .login
    fi
fi
if [ $Fund -eq 0 ]; then
    cat <<-'EOF' | sed -e "s/%%Datum%%/$Datum/" >> .login
	#
	#	This change was added on %%Datum%%
	#
	if (! $?DISPLAY) then
	    set PID=`ps -lwx | egrep -w 'X11|XDarwin' | grep -v grep | awk '{print $2}' | head -1`
	    if ("$PID" !~ '') then
	        setenv DISPLAY `ps -wwwe -p $PID | grep DISPLAY | sed -e 's/^.*DISPLAY=\([^ ]*\) .*$/\1/'`
	    else
	        set Anzahl=`top -FRl 1 | grep Finder | wc -l`   # OR loginwindo OR ATSServer OR SystemUIServer OR Dock OR pbs ...
	        @ Anzahl --
	        setenv DISPLAY :${Anzahl}
	    endif
	endif
	alias updisp	'setenv DISPLAY `defaults read "${HOME}/.MacOSX/environment" DISPLAY`'
	#
	#	End of change from %%Datum%%
EOF
else
    echo "......###################################################"
    echo "....... Your ~/.login might already contain all things"
    echo "....... needed to make a Mac TeX work in X11 ..."
    echo "....... But you better check this!"
    echo "......###################################################"
    exit 1
fi
